---
title: 如今
lastmod: 2025-04-20
---

这里是园子的「如今」页面，也称：

> 某只小氯酱的精神状态信息公示板

## 前言

### 这个页面是怎么来的？

本页面的灵感源头应当是 [Derek Sivers](https://sive.rs) 创建的网站 <https://nownownow.com>。引用 Derek 在网站中的解释：

> Most websites have a link that says “about”. It goes to a page that tells you something about the background of this person or business. For short, people just call it an “about page”.
> 
> Most websites have a link that says “contact”. It goes to a page that tells you how to contact this person or business. For short, people just call it a “contact page”.
> 
> So a website with a link that says “now” goes to a page that tells you what this person is focused on at this point in their life. For short, we call it a “now page”.

Now Page，我将其翻译为「如今」页面，是一个总结当前的生活状态和内容的页面。

### 那么 Twitter / 微博 / TG Channel / Fediverse / Bluesky / ... 呢？

很好的问题。这些平台的好处在于可以随时随地分享生活，而缺点正如 Derek 所说的：**这些碎片化的分享拼不出生活的大局**。

> Think of **what you’d tell a friend you hadn’t seen in a year**.

或者，用我回复[道与](https://daoyuchan.com/)老友的评论来说：

> 感觉 Now 页面更像是对近期自己生活状态的一种反思和概述，所以我把它翻译为「如今」。平时细节上的碎碎念就全用说说承包了。

### 其他信息

Derek 在 NowNowNow 中对如今页面的作用等做出了很详细的解释。我比较赞同他的观点，大家可以前往[这里](https://nownownow.com/about)阅读。

此外，虽然 Now Page 的倡议是 Derek 发出的，但我第一次接触这个页面，应当是在[青山大佬](https://yinji.org)的博客中。这是我需要注明的 Honor Code。

以及，园子第一条真正的评论由嗣檙老友在这里打下，因此为表纪念，此处的留言将永久开放。

### 最近更新时间

乙巳年（蛇）三月廿四，西历 2025 年 4 月 20 日。

## 小氯

小氯能是什么样子呢？

依然是一只旅居地球的元素娘，所有为未来而不同程度苦恼的大学生中的一员。依然每天做梦，眼高手低。所幸还会想着去做梦。

头发剪短了些，看着似乎更冷淡了。

健康状况的话，目前基本还是那个样子。手术恢复得差不多了，正常走路甚至是慢跑几步都没有太大问题；痛风和关节炎也没有再发作过。这已经很好了。

## 生活概况

### 休息

最近刚刚结束兵荒马乱的期中季，得到了一点难得的闲暇。先短暂地让自己休息一下吧，不论未来如何。

小氯很想一直休息，但一直休息大抵就不是休息了。

### 学统计

呜呜呜 Statistics 酱我好喜欢好喜欢你啊 （ ＴДＴ）

小氯一直对概统课程的推荐修读时间如此之晚感到极其不解。在小氯看来，统计学对于我们专业的重要性不逊色于数学分析，甚至更重要（~~统计对于任何一个专业都很重要好吧~~）。但事实上非但没有多加一些随机过程、时间序列分析、贝叶斯方法之类的深入课程，反而把概统课的修读时间调得如此之晚。小氯对此感到费解。

### 装修园子

这里的「装修」其实不太准确，小氯喜欢用这个词来指代代码层面和视觉风格的改善。更好的叫法或许是修剪枝叶。

或者我们换一个更加人类友好的说法吧：小氯最近在对园子做一些内容层面的改版和重构，包括站名的更改、页面的重构和大量的隐私工作。同时，园子的全站开源平台也从 GitHub 换到了 Codeberg。自由的文字，理应生长于自由的土壤。

### 吃果酱

不知道是出于什么动机，最近去便利店扫货的时候，顺带着买了一瓶果酱。比较贵的小东西，一瓶的价格抵得上一包全麦面包了。

然而买回来之后并不清楚该用来做什么，思来想去也只好像小的时候那样，在面包片上抹果酱做早餐了。味道还不错，毕竟小氯喜欢水果。

### 收拾行囊

马上要到五一了。小氯这个五一打算试着自己出去走一走，准确来说是去世界渴望之城——重庆（我不太清楚这个外号是怎么来的，是立体程度吗？）看一看。小氯在重庆有一位故交知己，聚一聚想必也是件令人十分欢喜的事。

### 试图重建社交网络

小氯前段时间比较闲的时候，经常想着折腾一下自己的社交网络。但是总感觉 Fedi 和 Bluesky 都有些不合心意，自己也不太能弄清自己基本满意的社交网络是什么样子的。最后干脆放任自己分享倦怠，一篇帖文也不发了。

相比之下 Matrix 运行得居然还相对稳定，虽然说小氯经常一言不合就删库重来。

### 收集《文明 VI》原声带

虽然听起来似乎挺琐碎的，但事实上也确实如此。

游戏，小氯是一分钟也不玩的；音乐，小氯是一首也不落的。何况文六的音乐是真的非常出色（我真的好喜欢好喜欢法兰西的音乐啊）。

目前能找到的大概只有 YouTube 和 B 站上的视频，而分享又位于万恶的百度网盘上，想下载下来估计需要个几天几夜。此外小氯也希望支持一下原作，不知道有什么购买的渠道。
