---
slug: weekly-6

summary: 浮生散记第六期
series: 岁时录
tags:
  - 周报
  - Zen
  - Matrix
  - AIGC

title: Ephemeralis-Weekly（6）：无可热爱
date: 2024-09-15
description: 本文是作者周报的第六期，以轻松幽默的语气分享了自己对多种主题的思考和体验。首先，作者介绍了Zen Browser这款新浏览器，虽然其界面设计精致、性能较好，但由于bug频繁且仅处于Alpha阶段，作者对其当前表现略有保留。接着，作者描述了用Rust编写的Matrix服务器实现Conduit的部署体验，指出其轻量高效的优点。随后，作者简评了豆包AI的绘画功能，并分享了自己使用AI生成头像的经历。最后，文章逐渐转向深刻的个人反思，讨论了生活中无谓的琐事、理想与现实的冲突，以及意义感的缺失，表达了对时代与个体生活的质疑、困惑与思考。
categories: ["人间世"]
featuredImage: https://img.viento.cc/cover/weekly-6-cover.webp
draft: false
---
各位老友们好，我是 Chlorine。一别旷日，心下甚念。

本文为园子周报——Ephemeralis Weekly（浮生散记）的第六期，日期范围为公历 2024 年 9 月 9 日至 9 月 15 日。祝食用愉快。

## Hello，Zen Browser

如果问我每天使用时间最长的应用程序是什么，那恐怕不是 VSCodium、Obsidian 或者微信，而是浏览器。浏览器是我们通往互联网的桥梁，也是我们与科技巨头的「隐私战争」最激烈的阵地之一。

现在浏览器市场的老大毫无疑问是 Chrome，如果我没记错，其市场占有率应该在 60% 以上，Edge、Safari、Firefox 和 Opera 等位居第二梯队。目前这几大浏览器中，唯一开源的是 Mozilla Firefox，这也是几个浏览器中公认对隐私尊重最好的。只不过，虽然 Firefox 是开源的，但是其和东家 Mozilla 也面临着很多非议（这会让人想到一些和 FOSS 意识形态有关的问题，小氯在这方面有一些不成熟的思考，有时间我会详细讲的）。于是，一些基于 Firefox 开发，但是预先做了许多隐私和安全方面处理的第三方分支出现了，我们姑且将之称为 pre-harden 版本。

关于 Firefox 的 pre-harden 版本，比较著名的应该是 [LibreWolf](https://librewolf.net)（我很难不怀疑开发者起名的用意）。LibreWolf 很好，但是从某种意义上来讲，有点太好了——它尽心尽力地去除了那些试图窃取我们隐私的虫豸，但是却没有帮我们补齐曾经我们用隐私换取的体验，或者说是补齐得不够。

而且，就我个人而言，我对于 LibreWolf 的界面不太满意。作为一个 Arc 重度用户，我对 Arc 精致的设计和交互非常着迷。而要在 LibreWolf 中达到一样的效果，需要费非常大的力气。

后来，我在 GitHub 上发现了另一个开源项目：[Zen Browser](https://github.com/zen-browser/desktop)，我们可以称其为「禅浏览器」。

在[他们的官网](https://zen-browser.app)上，开发者高调地宣称：

> Zen is the best way to browse the web.

虽然比不上 Arc 的「改变整个互联网」这么自信，但是这个宣传语也已经够让人眼前一~~黑~~亮了。于是我下载了这个浏览器，并将其作为主力使用了一段时间。

那这个浏览器能配得上这个宣传吗？

**很遗憾，就我目前的体验，暂时还不能。**

总体而言，Zen 的交互在 Firefox 系浏览器中是相当精致的，甚至可以说是最精致的，没有之一。可以看出开发者的确下了很大的功夫去设计界面交互。就原生侧边栏这一个功能，就是难得可贵的了。其速度和内存占用要好于 Arc，但是没有达到明显优于的级别。在界面设计方面，还存在一些我不是很满意的细节，然而我不会改 Firefox 的 CSS，于是只好干瞪眼；而且，其目前为止还存在很多 bug，例如无法保持许多自定义设置（例如 DNS 保护中的偏好等级，甚至是侧边栏钉住的标签页都无法保留）。

那我为什么还是保留了它？

说出来大家可能不信：这个浏览器，到现在还只是 Alpha 版本，连 Beta 都不是。[^1]这么一说，好像前面的所有 bug 都变得合理了。

但是我并不这么认为。作为一个项目，Alpha 版本存在错误可以得到 Fellows 的理解；但是作为一个产品，存在错误可不会得到用户理解。当然，我这么说并不是在对 Zen 吹毛求疵、严以待人，Zen 是一个非常优秀且未来可期的产品，我希望表达的意思是：如果各位老友希望使用 Zen，请注意和明确直至完全理解可能要承担的风险。

## Hello，Conduit

[Conduit](https://conduit.rs) 是一个用 Rust 写的 [Matrix](https://matrix.org) 服务器实现，具有超轻量、高性能等优点。我看了一圈，目前简中圈的相关资料似乎不是特别多。

### 部署

我们依然使用美好的 Docker。

找个你喜欢的目录，创建 `docker-compose.yml`：

```yaml
# Conduit
version: '3'

services:
    homeserver:
        image: matrixconduit/matrix-conduit:latest
        restart: unless-stopped
        ports:
            - 8448:6167 # 左边的端口可以改一个你喜欢的
        volumes:
            - ./db:/var/lib/matrix-conduit/
        environment:
            CONDUIT_SERVER_NAME: 你的实例域名
            CONDUIT_DATABASE_PATH: /var/lib/matrix-conduit/
            CONDUIT_DATABASE_BACKEND: rocksdb
            CONDUIT_PORT: 6167
            CONDUIT_MAX_REQUEST_SIZE: 20000000 # in bytes, ~20 MB
            CONDUIT_ALLOW_REGISTRATION: 'true'
            CONDUIT_ALLOW_FEDERATION: 'true'
            CONDUIT_ALLOW_CHECK_FOR_UPDATES: 'true'
            CONDUIT_TRUSTED_SERVERS: '["matrix.org"]' # 我们信任的实例，会进行优先通信
            # CONDUIT_MAX_CONCURRENT_REQUESTS: 100
            CONDUIT_ADDRESS: 0.0.0.0
            CONDUIT_CONFIG: '' # Ignore this
volumes:
    db:

```

然后直接部署即可：

```bash
docker-compose up -d
```

部署成功后，访问你部署的地址，如果看到一串「Hello from Conduit!」，那么恭喜你部署成功。

### 注册

由于 Conduit 不带 Web 界面（原本的 `docker-compose.yml` 把这个部分注释了，我直接给删除了），所以我们需要找个 Matrix 的客户端进行注册，比方说 Element 之类的。

第一个注册的用户会成为管理员。注册成功后建议把配置文件的 `CONDUIT_ALLOW_REGISTRATION` 改成 `false`，防止有人恶意注册。

我目前的 Matrix 就采用自己的私有实例。但是吧，我的虚拟机在校园网内访问经常抽风，造成 Matrix 服务也不大稳定，因此我准备了一个备用账户。

我一直想用 Matrix Bot 代替飞书 Webhook，但是我还不会。

## Hello，豆包

~~你这写的到底是周报还是 Hello 宇宙文集？~~

很早就听说过字节家的豆包 AI，但是没用过。这几天翻[木木老师](https://immmmm.com)的博客说说，发现木木老师对豆包的 AI 绘画赞不绝口，于是我打算尝尝鲜。

试了一段时间，总体感觉属于还可以的水平，文字问答和 Kimi AI 差不多。其他的功能，像音乐生成和智能搜索我还没试过。

不过有一说一，这个 AI 绘画是真的可以。我用祖传的 prompt 去炼了会金，炼出了一些看着蛮不错的照片，其中包括小氯现在的头像。

——准确来说，是我头像的原图。

简单来说呢，我对头像的制作非常满意（虽然说细节上还有一些瑕疵吧），但是我试着将其换成头像后，远看起来，人物的腿部非常显眼，事实上也的确存在一定面积的裸露（我目测是四分之三长度）。

这不算是一个很暴露的比例，但是已经足以让一些较为严格的审查亮出黄牌了。我用凉心云的审核系统检测了一下，果然被警告了。

作为一位遵纪守法的独立博主，我不能接受这个事实。于是我花了很大力气，终于为人物加上了合适的衣着，也就是各位老友现在看到的头像。虽然细节处理上并不出色，但是至少可以用了：这个版本是全年龄段适宜的，至少就我国法律而言，不会碰到任何意义上的红线。

反正总而言之，豆包 AI 的绘画确实很不错，大家可以试着玩一玩。

## 开学

~~终于讲点正事了~~

从 9 月 9 日开始，小氯就正式开学了。一周下来体验就一个字：累。小氯本学期的专业课非常抽象。尽管第一周的事情很少，但是小氯也已经感受到了令人咋舌的压力。

不过幸好，第一周完事就是美好的中秋假期，可以稍稍~~摆会烂~~喘口气。我很难想象，到了期中和期末会是怎样一番勃勃生机万物竞发的盛景。

## 无可热爱

> [!CAUTION]
> 警告：下面的若干段话相当的幼稚和矫情。各位老友可以先回自己的房间，我会把线上故事打开。这样如果不想听，直接关掉即可。我不希望周报变成另外一场无聊而冗长的会议。

当我写下这段话时，我正在开一段非常无聊且冗长的会。台下的每个人看起来都生无可恋，我怀疑台上的实际上也是。

我的心情不太好。刚刚收到了 [Physnya](https://physnya.top) 老友的邀请邮件，希望能去新生舞会面基。插句话，Physnya 老友应该是目前离小氯地理位置最近的一位了，平时可能在几百米以内（第二近的可能是[杜老师](https://dusays.com)？）。说实话我还是蛮心动的，除开可以和老友面基外，毕竟当初三字班的新生舞会我还没参加，虽然我腿脚不好且在运动方面毫无天赋，但借着四字班的学弟学妹们的活动感受一下氛围也不错。

然而我去不了。我只能在会议上摸摸鱼，抓紧讲话的间隙做一点工作，或者写写代码。

当然，经常在会议上摸鱼的朋友都知道，这样的效率不高，甚至极低。于是小氯的情绪变得非常不稳定~~想随机找一位幸运观众进行氧化~~。

趁着中场休息的功夫我跑去接了瓶水，然后在外面东倒西歪地走，假装自己可以不太清醒地耍耍酒疯（各位老友应该知道，小氯因为身体原因不能喝酒）。

越喝我的情绪越不稳定，到最后内心只剩一个想法：

> 我到底在这干什么？这不就是在浪费生命吗？

没错，完完全全就是浪费生命。把本来可以认认真真写代码，或者去和老友畅谈文事共叙旧谊丰富人生体验，或者只是在紫操走一走吹吹风听听歌的时间花在一场结束后不会对我有任何技能价值或情绪价值的会议上，顺便还会导致我今天睡得不好。

恕我直言，作为一个学过经济学原理的人，我面对这种效率和公平一点不沾边的行为会感到异常不满。

既然都已经不满了，索性让我再多吐槽几句吧。

我们的日子到底充斥着多少这样浪费时间的无谓之举？把最好的时光花在不得不做的乱七八糟的琐事或者自我麻痹的短视频上，到头来只留下了无穷无尽的空虚。这样日复一日年复一年，找不到任何可依托的锚点，没有任何喜欢或者追求的事物，到头来就像秦始皇陵地下的兵马俑，只剩下一副干瘪的躯壳，即使摆出笑的造型都不知道有什么可高兴的。

我不止一次发出过这样的质疑。一般我用来自我安慰的方式有两种，温和派就是那句曾经激励我的「热爱可抵岁月漫长」，激进派不太喜欢给人留面子，会直接劈头盖脸地斥责你：你的所有空虚、寂寞、伤感、迷茫，归根结底就两个字：闲的。

**好，那小氯今天倒是想问一句：我们应该热爱什么？就算我们不闲下来，每天忙忙碌碌过着「充实」的生活，那又是为了什么？**

千人千面的问题。但是只要我们追问几句，一切看似冠冕堂皇或者热血沸腾的答案都会被审视的大剑劈成苍白无力的自证的碎块。

这是一个意义被解构的时代，一切的崇高都可以被从神坛上拉下，被粗暴地揭去其金色的铠甲或长袍。泛娱乐化消解了严肃性，怀疑主义动摇了合理性，而功利主义打碎了理想性。意义一旦被解构，就几乎无法重建，如同破镜不能重圆。我们自然可以用理性去批判其中的不合理之处，但是就像《天下第一楼》中说的，「一个人干，八个人拆」，意义的崩塌可比建构快多了。而怀疑的种子一旦种下，必然会在一个不太远的时间引发一场思想的雪崩。

这个问题在高中几乎是不存在的——至少就小氯的人生经历来说。高中是一个极其纯粹的阶段，除了学习几乎不需要接触任何其他事情。这就造成我们的理想主义可以安心地躲在长城之后，免于任何铁骑的冲击。而一切疑问都可以被「考一个好大学」所掩盖，大学生活本身的神秘性也为这种推脱提供了情感上的有力支持。因此，小氯可以一天做上十几张卷而不去想为什么要去做卷，而一句「追逐人类心智的荣耀」就足以让人热血沸腾许久。

但是乐园消失了就无法重建，朴素集合论和形式主义系统再令人沉醉也逃不过 Russell 悖论和 Gödel 不完备性定理的恶魔。我们当然可以用下一个大众意义眼中的「人生阶段」作为自己的目标来继续激励自己，例如说保研或者国外升学或者 Offer，但是我们永远逃不开这个意义的终极追问。科幻文学界可以「嘲笑宏大叙事，消解终极追问」，[^2]但是作为个体的我们却无法忽视这个自我幻境之中的阿喀琉斯之踵。至于将自己的目光放近，只是感受生活中的小确幸，抑或守护自己身边的熟悉一隅，这种生活方式「虽然清丽飘逸，但却独欠风骨」。而且我很怀疑，武陵人是否真的能回到桃花源。至于搞钱，似乎只有利欲熏心的资本家才能将其作为人生的终极意义，而且在当下的经济形势，估计这个目标也难以为继。

一旦人无可热爱，意义的消解就是生活的破碎。工作变成了苦兮兮的打工，娱乐变成了自我麻痹的无形酒精。人的断片从未消解，而是以另一种形式延续下来，并且正在侵蚀人心的道路上披荆斩棘一往无前。文明精神上的熵增似乎已经不可避免，最后也不知会来一场现实意义的赛博朋克 2077，还是幸存者在辐射的废土上苟延残喘，或者是数据主义的洪流如人曾经洗刷掉动物和神明一般洗刷掉人类，将曾经在进步和吹嘘中飘飘然认为自己可以万世长存的文明如泥石流中的土块般冲散。这么看来，全体人类搬进元宇宙倒可以算是一个相当好的 HE，起码在一段时间内，可以享受一个所谓「质料与原本完全不同，因而问题也不再存在」的世界——不过我并不认为元宇宙里就不用上班，很可能变成二次元人物之后还得打工。

说了这么多，感觉对于每一个个体而言，除了被博弈论嘲笑的微乎其微的团结的希望，似乎剩下的唯一选择就是不去思考终极问题，用上文所述的方法去欺骗自己一生。不是说这样不好，这样可以过得相当幸福，甚至可以成为一个伟大的人——通常意义上的，创造出丰富的物质和精神价值。

**然而我们必须思考**。

我曾经做过一个心理测试，里面有一道题：清醒地痛苦和糊涂地幸福，你选择哪个？

我当时选择的是前者，我记得。但是现在看来，这根本不是一个能选的问题，因为能够不思考的，估计只有被圈养的动物。

---

乱七八糟说了一大堆不知所云的话，抱歉污染到各位老友的时间线了。

按理说，小氯作为一个在大众意义上被认为是未来的精英群体或者国家栋梁的年轻人的群体的一员，不应该如此「悲观」，但是，很可能正因为看得更多，才会想得更多。当然，更大的可能是只是在没有看清世界全貌时的无病呻吟。我希望是后者。

[^1]: 简单科普一下：Alpha 是软件开发的早期版本，相当于「内部测试版本」；而 Beta 可以看作「公测版本」。
    
[^2]: 出自《三体》的序言，不知记得是否准确。
