---
title: 收集一些最近发现的网站
summary: 小氯，你好闲啊
description: 本文分享了作者Chlorine发现的一系列有趣网站，包括时间线生成器MyLens、在线百科全书Encyclopedia Britannica、中国古代妖怪资料库纪妖、佛罗里达奇闻异事集锦Florida Man、博客封面制作工具CoverPaint、代码图片生成器 Carbon、截图美化工具 Pica、Google的开源图片压缩工具Squoosh、森林声音白噪声网站tree.fm、展示全球风景的WindowSwap、加密消息生成器Saltify、临时手机号提供者AnonymSMS、临时邮箱服务10 Minute Mail、模拟黑客打字效果的Hacker Typer，以及随机跳转至有趣网站的The Useless Web。作者还提到通过搜索和随机浏览互联网可以发现更多有趣的网站。
date: 2024-01-28
categories: ["逍遥游"]
tags:
  - 安利
slug: some-websites
---

嗨，大家好，我是 Chlorine。

最近发现了不少有意思的网站，本来打算在周报里提一下就可以了，奈何有点太多了，因此决定单独写一篇。

> **宇宙安全声明**
>
> 我所指的“有意思”标准比较个人化，同时对于常用的实用网站和一些适合摸鱼的网站基本没有收录，大家也不必较真什么叫有意思，你杠你对。

## MyLens

地址： https://mylens.ai/

在逛博主[青山](https://yinji.org)的博客时发现的，作用是根据提示词生成相关的时间线，提示词中英文均可。以下是我测试的几个结果：

![|681](https://img.viento.cc/IMG-20240128120000-1.webp)

![|676](https://img.viento.cc/IMG-20240128120000-2.webp)

![|681](https://img.viento.cc/IMG-20240128120000-3.webp)

生成后可以下载一个 zip，里面有这种长图和一组用来分享的切图，蛮好玩的。

## Encyclopedia Britannica

地址: https://www.britannica.com/

我翻译一下，这个网站的中文名叫：《大英百科全书》.

没错，就是那一部“一部足以代表现代文明精华的世界级经典，辉煌时代的智慧结晶，一所没有围墙的大学，仅次于上帝的权威”。

现在都在互联网上了，尽情享用吧。

## 纪妖

地址： https://www.cbaigui.com/

收集中国古代的妖怪们，不错的小说素材发掘地。

## Florida Man

地址： https://floridaman.com/

这个网站我发现得比较早, 但是我还是忍不住写了下来.

佛州地方，物华天宝，人杰地灵。同时感谢佛州官方公开的案件记录，让我们能更直接地欣赏到佛州英雄好汉对于地球 online 中人类系统 bug 的绝妙利用。

![|441](https://img.viento.cc/IMG-20240128120000-4.webp)

比抽象搞笑视频更搞笑，还能顺便练英语，谁不喜欢呢。

我随便翻译两个不是很恶心的吧，翻译水平有限，请见谅：

[佛罗里达一曾盗窃沃尔玛的女子打算在沃尔玛求职](https://floridaman.com/florida-woman-stole-walmart-plans-apply-job-walmart/)

[一头上有佛州纹身的男子打电话让 911送他回家](https://floridaman.com/state-tattooed-on-head-calls-911-for-a-ride-home/)

[佛罗里达一男子将“只踩油门不刹车”纹在脖子上炫耀驾驶技术，结果在逃脱警察追捕时撞车](https://floridaman.com/florida-man-with-all-gas-no-brakes-neck-tattoo-crashes-while-fleeing-police-video/)

[佛罗里达一男子被复活节小兔暴打](https://floridaman.com/florida-man-gets-beat-up-by-the-easter-bunny/)

[佛罗里达一男子试图射杀小狗，结果被小狗反杀](https://floridaman.com/florida-man-tries-shoot-puppy-puppy-shoots-instead/)

## CoverPaint

地址： https://coverpaint.xiaole.site/zh

一个 Github 的开源项目，用于制作格式统一的博客封面。

放下我这周周报的封面：

![]() ![](https://img.viento.cc/IMG-20240128120000-5.webp)
图片依然来自优秀的 [Unsplash](https://unsplash.com/).

项目的仓库在 https://github.com/youngle316/cover-paint , 看样子能自部署，可惜现在我只会用 Vercel, 看不懂思密达。

## Carbon

地址： https://carbon.now.sh/

字面意思是碳，实际效果相当于碳的某同素异形体。

![|558](https://img.viento.cc/IMG-20240128120000-6.webp)

这个网站的作用是把代码变成易于分享的好看图片，我贴个自己做的图吧。

![毁灭吧.webp(doge)|392](https://img.viento.cc/IMG-20240128120000-7.webp)

各种样式都蛮丰富的，喜欢贴代码图的小伙伴应该会喜欢。

## Pica

地址： https://pika.style/

帮你美化你的截图，设计师们可能会喜欢吧。

## Squoosh

地址： https://squoosh.app/

来自 Google 的开源图片压缩网站，压缩速度和质量好得夸张。唯一的缺点是不支持批量压缩。

自从发现了这个网站后，我就丢掉了访问极度不稳定的 tinypng. 这个网站在我现在写博客的过程中功不可没，我的每一张图片都会丢进去极限压缩并导出 `.webp`，来把大小缩减到最低。

源代码在 https://github.com/GoogleChromeLabs/squoosh , 技术力高的朋友可以自己部署，我就只用 Edge 自带的功能，把网页下载到本地变成应用了。

值得一提的是，这个网站在大陆也可以访问。

## tree.fm

地址： https://www.tree.fm/

聆听森林的声音。当一个白噪声电台挺不错的。

## WindowSwap

地址： https://www.window-swap.com/

想看看，此时世界上的另一个人，窗外是怎样的风景吗？

## Saltify

地址： https://www.saltify.io/

字面意思是盐化，但是和食盐没什么关系。

这个网站可以生成带有密码和生命周期的消息，感觉适合用来说悄悄话。

## AnonymSMS

地址： https://anonymsms.com/

一个匿名短信验证网站，可以给你提供一个临时的手机号接验证码。原本好像只有米国和带嘤的手机号，现在多了几个地区。

不知道能不能用这个网站申请 ChatGPT API 一类的服务？🤣

## 10 Minute Mail

地址： https://10minutemail.com/

字面意思，创建一个临时邮箱，和上面的 AnonymSMS 功能相似。

## Hacker Typer

地址： https://hackertyper.com/

黑客模拟器，一个在键盘上随便乱打就能假装你是黑客的网站。大小所限，我就不放 GIF 了。

![|502](https://img.viento.cc/IMG-20240128120000-8.webp)

不过，这个网站也只能拿来装装，真想有黑客的技术力，还是得好好学计算机～

## The Useless Web

地址： https://theuselessweb.com/

一个网站任意门，可以带你随机穿越到一个没什么用的网站。

---

先说这么多吧，今天或者明天会更周报。

关于发现这些网站的方式，可以在 Google 里直接键入 interesting websites，里面就会有很多推荐，在发现国外网站方面尤其好用。当然，也可以在互联网中随机游走，会随缘碰到一些网站。
