---
title: Obsidian+Hugo建站教程：0-前言
date: 2024-02-16T18:49:34
categories: ["百草园"]
tags:
  - 博客
  - 教程
  - Obsidian
featuredImage: https://img.viento.cc/cover/how-to-build-a-blog-0-cover.webp
slug: how-to-build-a-blog-0
series: Obsidian+Hugo建站教程（已鸽）
summary: Obsidian + Hugo 建站教程前言
description: 本文是作者关于从 NotionNext 迁移到 Hugo 博客系统的系列文章的开端。文章首先解释了静态博客和独立博客的概念，强调了独立博客的自主性、自由度以及与读者互动的紧密性，同时也指出了其成本、技术要求等缺点。接着，作者提出了独立博客写作的最佳实践，并列出了进行博客写作和管理所需的基本技能和工具。文章最后以一个博物馆的比喻预告了后续将详细讲解博客搭建的各个步骤，旨在为读者提供一个全面的指南。
---
声明：

细心如你，应该已经发现了，本期的链接，build 变成了 bulid……

其实我已经发现了，但是我又发现，Twikoo 这货，文章 slug 改了之后，居然评论就没了……

$$
\begin{cases}
x = \sin t, \\ 
y = \frac{t \cos t}{2}
\end{cases} 
\quad 0 \leq t \leq 2 \pi
$$

更新：在修改 MongoDB 数据库之后，链接正常了（

---

嗨，大家好，我是 Chlorine。

折腾了一天多，终于完成了从 NotionNext 到 Hugo 的迁移。这个系列的目的就是记录我搭建博客的历程，同时我会尽可能写得详细一点，为同样零基础的老友们提供一点帮助。

本来想给这个系列起一个炫酷的名字，但是想了想，还是使用两个主要工具进行命名吧，也方便想找解决方案的老友们。

本系列的封面图作者为 Unsplash 的 [Luke Stackpoole](https://unsplash.com/@withluke)。

## 独立博客简介

### What？

什么是静态博客呢？

要说静态博客，首先要说独立博客。

说到博客——或者类似的服务，大家可能会想到新浪微博、知乎、CSDN、博客园等。这样的平台只要注册一个账号，开始写就完事。

例如，我们打开一个博主的知乎首页，我们访问的域名（地址栏里那串字符）一般是这样的： https://www.zhihu.com/people/xxxxx ；而你现在访问我的博客首页，链接是这样的： https://yoghurtlee.com 。

看出区别了吗？直观上来看，知乎首页的域名是依托于知乎的域名的，而我的博客的域名是我自有的。

独立博客指的是不依赖于社交媒体平台或内容聚合网站、拥有自己的域名和托管服务的博客。这样的博客通常由博主自己或者一个小团队进行运营，具有更高的自定义程度，允许博主完全控制网站的设计、内容和功能。这种类型的博客可以是个人兴趣、专业领域分享、商业推广或任何其他目的。

### Why？

关于为什么写静态博客而不是在大型博客平台上进行写作，我概括了以下几点原因：

- 独立的域名和服务——网站的全自有性
  - 数据掌握在自己手中
  - 站点权重和搜索引擎优化（SEO，简单来讲就是你的网站在搜索引擎的位次）我命由我
- 高度自由化——独立博客一般都基于开源框架，客制性极高
- 不受平台审核规则的限制——内容（合法范围内的）自由
- 与读者更好的互动——这是我的个人感觉，一个订阅人数不过百的小站，比一个几万粉丝的平台号与读者的关系紧密许多
- 盈利性
  - 独立网站可以成为高价值的虚拟财产
  - 在流量足够且你愿意的情况下，你可以通过广告或推广营收

当然，独立博客也有缺点：

- 成本——零成本建站当然是完全可行的，但是如果你想拥有自己的顶级域名（TLD）和服务器，那还是需要一点成本的
- 小众性——博客本身就是一个小众的爱好，我们的站点（目前）又是属于再小不过的站点。
- 技术要求——即使是门槛最低的建站，也比注册一个账号开始写复杂很多。当然，看着教程建站还是相当简单的～
- 低流量性——上一条的直接结果
- 孤独性——这点很复杂和无奈，大家先从直观上想象一下吧

## Best Practice

下面是我认为的，独立博客写作的最佳实践。

- 稳定的域名和 DNS 解析服务。
- 在本地快速创建带有相应属性值的博客文章。
- 使用标准的 Markdown（准确来说，此处指的是 GFM）语法进行书写。
- 使用图床进行图片的管理。
- 写作完成后一键上传到 Git 仓库。
- 站点部署工具自动嗅探仓库变动进行部署。
- 更新完成。

以下我们的所有文章，都围绕着这个 Best Practice 展开。

## 你必须会的东西

下面的东西是必须会的，如果这些都不会，我就真没辙了。

- GitHub/Gitee 账号的注册，仓库的 fork
- Markdown 语法。如果你不习惯 md，那你可能是走错地方了。
- Git 提交（后面会简单讲如何在 VS Code 中可视化提交）

## 我们需要的东西

- 域名：我们以 Dynadot 为例
- DNS 解析服务（Opt.）：我们以 CloudFlare 为例
- 博客框架：我们以 Hugo 为例
- Git 仓库：我们以 GitHub 为例
- 部署服务：我们以 Vercel 为例
- Markdown 编辑器：我们以 Obsidian 为例
- 图床（Opt.）：我们以缤纷云对象存储为例
- 评论系统（Opt.）：我们以 Twikoo 为例

下面我会使用“数字博物馆”这个比喻，将搭建博客的每一步都尽可能讲清楚，希望能够给大家带来一些帮助。

> 独立博客，启动！
